#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "md5.h"

#define STRING1 "Wake! For the Sun, who scatter'd into flight\n"
#define STRING2 "The Stars before him from the Field of Night,\n"
#define STRING3 "\240\240\240Drives Night along with them from Heav'n, and strikes\n"
#define STRING4 "The Sult\341n's Turret with a Shaft of Light.\n"

typedef struct magic_string_state_s {
  char vowel;
  char sequent;
} magic_string_state_t;

const char *
magic_string (unsigned char data_byte, magic_string_state_t *st, char final)
{
  const char *s;

  if ( data_byte%7 == 0 && st->sequent && ! final )
    {
      st->sequent = 0;
      return " ";
    }
  st->sequent = 1;
  if ( st->vowel )
    {
      st->vowel = 0;
      if ( data_byte < 40 ) s = "a";
      else if ( data_byte < 80 ) s = "e";
      else if ( data_byte < 115 ) s = "i";
      else if ( data_byte < 145 ) s = "o";
      else if ( data_byte < 175 ) s = "u";
      else if ( data_byte < 195 ) s = "y";
      else if ( data_byte < 200 ) s = "ai";
      else if ( data_byte < 205 ) s = "ei";
      else if ( data_byte < 210 ) s = "oi";
      else if ( data_byte < 215 ) s = "au";
      else if ( data_byte < 220 ) s = "eu";
      else if ( data_byte < 225 ) s = "ou";
      else if ( data_byte < 230 ) s = "ae";
      else if ( data_byte < 235 ) s = "oe";
      else if ( data_byte < 240 ) s = "aa";
      else if ( data_byte < 250 ) s = "'";
      else s = "";
    } else {
      st->vowel = 1;
      if ( data_byte < 12 ) s = "p";
      else if ( data_byte < 24 ) s = "b";
      else if ( data_byte < 36 ) s = "t";
      else if ( data_byte < 48 ) s = "d";
      else if ( data_byte < 60 ) s = "k";
      else if ( data_byte < 72 ) s = "g";
      else if ( data_byte < 84 ) s = "s";
      else if ( data_byte < 96 ) s = "z";
      else if ( data_byte < 108 ) s = "sh";
      else if ( data_byte < 120 ) s = "zh";
      else if ( data_byte < 132 ) s = "f";
      else if ( data_byte < 144 ) s = "v";
      else if ( data_byte < 156 ) s = "ch";
      else if ( data_byte < 168 ) s = "j";
      else if ( data_byte < 174 ) s = "ks";
      else if ( data_byte < 180 ) s = "x";
      else if ( data_byte < 192 ) { s = "h"; st->vowel = (data_byte<190); }
      else if ( data_byte < 204 ) { s = "n"; st->vowel = (data_byte<198); }
      else if ( data_byte < 216 ) { s = "r"; st->vowel = (data_byte<210); }
      else if ( data_byte < 222 ) s = "st";
      else if ( data_byte < 228 ) s = "zd";
      else if ( data_byte < 234 ) s = "ts";
      else if ( data_byte < 240 ) s = "dz";
      else if ( data_byte < 242 ) s = "pn";
      else if ( data_byte < 244 ) s = "bn";
      else if ( data_byte < 247 ) s = "sht";
      else if ( data_byte < 250 ) s = "zhd";
      else s = "";
    }
  return s;
}

void
page_make_name (const char *seed, char *buf, size_t buflen)
{
  struct MD5Context context;
  unsigned char data[64];
  int i;
  magic_string_state_t st;
  const char *s;
  size_t l;

  if ( buflen <= 0 )
    return;
  MD5Init (&context);
  MD5Update (&context, (const unsigned char *)STRING1,
	     strlen (STRING1));
  MD5Update (&context, (const unsigned char *)seed,
	     strlen (seed));
  MD5Final (data, &context);
  MD5Init (&context);
  MD5Update (&context, (const unsigned char *)STRING2,
	     strlen (STRING2));
  MD5Update (&context, (const unsigned char *)seed,
	     strlen (seed));
  MD5Final (data+16, &context);
  MD5Init (&context);
  MD5Update (&context, (const unsigned char *)STRING3,
	     strlen (STRING3));
  MD5Update (&context, (const unsigned char *)seed,
	     strlen (seed));
  MD5Final (data+32, &context);
  MD5Init (&context);
  MD5Update (&context, (const unsigned char *)STRING4,
	     strlen (STRING4));
  MD5Update (&context, (const unsigned char *)seed,
	     strlen (seed));
  MD5Final (data+48, &context);
  memset (&st, 0, sizeof (st));
  buf[0] = '\0';
  for ( i=0 ; i<64 ; i++ )
    {
      s = magic_string (data[i], &st, i==63);
      l = strlen (s);
      if ( l < buflen )
	{
	  strcpy (buf, s);
	  buf += l;
	  buflen -= l;
	}
      else break;
    }
}

const char *path_info;
const char *server_name;
const char *server_port;
const char *script_name;

#define BUFLEN 4096

char url_start[BUFLEN];

char page_name[BUFLEN];

int
main (int argc, char *argv[])
{
  int i;

  path_info = getenv ("PATH_INFO");
  if ( ! path_info || (strcmp (path_info, "") == 0) )
    path_info = "/";
  server_name = getenv ("SERVER_NAME");
  server_port = getenv ("SERVER_PORT");
  script_name = getenv ("SCRIPT_NAME");
  if ( ! script_name )
    script_name = "/cgi-bin/infinity";
  if ( server_name )
    {
      strcpy (url_start, "http://");
      strncat (url_start, server_name, BUFLEN-200);
      if ( server_port && (strcmp (server_port, "80") != 0) )
	{
	  strcat (url_start, ":");
	  strncat (url_start, server_port, 20);
	}
    }
  else strcpy (url_start, "");
  page_make_name (path_info, page_name, BUFLEN-200);
  printf ("Last-Modified: Mon, 06 Sep 1999 18:40:00 GMT\r\n"
	  "Content-Type: text/html\r\n"
	  "\r\n");
  printf ("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" "
	  "\"http://www.w3.org/TR/REC-html40/strict.dtd\">\r\n\r\n"
	  "<html>\r\n\r\n\r\n<head>\r\n\r\n"
	  "<title>%s</title>\r\n\r\n", page_name);
  printf ("<meta name=\"robots\" content=\"noindex, nofollow\">\r\n\r\n"
	  "<meta name=\"description\" content=\"One Page from the Book "
	  "of Infinity\">\r\n\r\n"
	  "<meta name=\"keywords\" content=\"infinite web space %s\">\r\n\r\n"
	  "</head>\r\n\r\n\r\n", page_name);
  printf ("<body>\r\n\r\n<h1>%s</h1>\r\n\r\n", page_name);
  printf ("<p>\r\nYou are in a maze of twisty little web pages, "
	  "all alike.\r\n\r\n");
  printf ("<p>\r\nFrom here you can get to the following places:\r\n\r\n"
	  "<ul>\r\n");
  for ( i=0 ; i<14 ; i++ )
    {
      char new_path[BUFLEN];
      char new_page_name[BUFLEN];
      size_t n;
      char *p;

      strncpy (new_path, path_info, BUFLEN-200);
      switch ( i )
	{
	case 0:
	  n = strlen (new_path);
	  while ( n > 1 )
	    {
	      new_path[--n] = '\0';
	      if ( new_path[n-1] == '/' )
		break;
	    }
	  break;
	case 1: strcat (new_path, "aries/"); break;
	case 2: strcat (new_path, "taurus/"); break;
	case 3: strcat (new_path, "gemini/"); break;
	case 4: strcat (new_path, "cancer/"); break;
	case 5: strcat (new_path, "leo/"); break;
	case 6: strcat (new_path, "virgo/"); break;
	case 7: strcat (new_path, "libra/"); break;
	case 8: strcat (new_path, "scorpius/"); break;
	case 9: strcat (new_path, "sagittarius/"); break;
	case 10: strcat (new_path, "capricornus/"); break;
	case 11: strcat (new_path, "aquarius/"); break;
	case 12: strcat (new_path, "pisces/"); break;
	case 13:
	  n = strlen (new_path);
	  while ( n > 1 )
	    {
	      new_path[--n] = '\0';
	      if ( new_path[n-1] == '/' )
		break;
	    }
	  p = page_name;
	  while ( n < BUFLEN-100 )
	    {
	      if ( *p == ' ' || *p == '\0' )
		break;
	      new_path[n++] = *p;
	      new_path[n] = '\0';
	      p++;
	    }
	  new_path[n++] = '/';
	  new_path[n] = '\0';
	}
      page_make_name (new_path, new_page_name, BUFLEN-200);
      printf ("<li>%s<a href=\"%s%s%s\">%s</a></li>\r\n",
	      (i==0)?"Back to ":"",
	      url_start, script_name, new_path, new_page_name);
    }
  printf ("</ul>\r\n\r\n");
  printf ("</body>\r\n</html>\r\n");
  return 0;
}
